// Importing libraries essentials for the phone
import processing.phone.*; // import phone library to go fullscreen
Phone myPhone;             // named reference to phone instance

//   ***************************************
//   *                                     *
//   * Snowball_Fight simulation_Prototype *
//   *                                     *
//   ***************************************
//
//    I    IUAV - Istituto Universitario di Architettura di Venezia
//   ---   Faculty of design and arts fDA, clasVEM
//    U    IxD Lab 1_2007-08, Laboratorio di comunicazione visuale e cinetica
//   ---   professors: Gillian Crampton Smith, Philip Tabor
//    A    students: Andrea Collet 263367, Maria Chiara Toncich 261507
//   ---
//    V    http://www.iuav.it - http://www.interaction-venice.com
// 
//         ------------
// 
//         Mode-switching system for screen change has been
//         developed by Nicholas Zambetti



////////////////////////////////////////////////////////////////////
// SCREENS DECLARATION AND DRAWING
////////////////////////////////////////////////////////////////////
// Names of the modes are given to match the image they are linked to.
int MODE_SNOWBALL00 = 0;
int MODE_SNOWBALL01 = 1;
int MODE_SNOWBALL02 = 2;
int MODE_SNOWBALL02_1 = 3;
int MODE_SNOWBALL02_2 = 4;
int MODE_SNOWBALL02_3 = 5;
int MODE_SNOWBALL03 = 6;
int MODE_SNOWBALL04 = 7;
int MODE_SNOWBALL04_1 = 8;
int MODE_SNOWBALL04_2 = 9;
int MODE_SNOWBALL05 = 10;
int MODE_SNOWBALL06 = 11;
int MODE_SNOWBALL07 = 12;
int MODE_SNOWBALL08 = 13;
int MODE_SNOWBALL08_1 = 14;
int MODE_SNOWBALL08_2 = 15;
int MODE_SNOWBALL08_3 = 16;
int MODE_SNOWBALL09 = 17;
int MODE_SNOWBALL09_1 = 18;
int MODE_SNOWBALL09_2 = 19;
int MODE_SNOWBALL09_3 = 20;
int MODE_SNOWBALL10 = 21;
int MODE_SNOWBALL10_1 = 22;
int MODE_SNOWBALL10_2 = 23;
int MODE_SNOWBALL10_3 = 24;
int MODE_SNOWBALL11 = 25;
int MODE_SNOWBALL11_1 = 26;
int MODE_SNOWBALL11_2 = 27;
int MODE_SNOWBALL11_3 = 28;
int MODE_SNOWBALL12 = 29;
int MODE_SNOWBALL13 = 30;
int MODE_SNOWBALL13_1 = 31;
int MODE_SNOWBALL13_2 = 32;
int MODE_SNOWBALL13_3 = 33;
int MODE_SNOWBALL14 = 34;
int MODE_SNOWBALL15 = 35;
int MODE_SNOWBALL15_1 = 36;
int MODE_SNOWBALL15_2 = 37;
int MODE_SNOWBALL15_3 = 38;
int MODE_SNOWBALL16 = 39;
int MODE_SNOWBALL17 = 40;
int MODE_SNOWBALL17_1 = 41;
int MODE_SNOWBALL17_2 = 42;
int MODE_SNOWBALL17_3 = 43;
int MODE_SNOWBALL18 = 44;
int MODE_SNOWBALL18_1 = 45;
int MODE_SNOWBALL18_2 = 46;
int MODE_SNOWBALL18_3 = 47;
int MODE_SNOWBALL19 = 48;
int MODE_SNOWBALL20 = 49;
int MODE_SNOWBALL20_1 = 50;
int MODE_SNOWBALL20_2 = 51;
int MODE_SNOWBALL20_3 = 52;
int MODE_SNOWBALL21 = 53;
int MODE_SNOWBALL22 = 54;
int MODE_SNOWBALL22_1 = 55;
int MODE_SNOWBALL22_2 = 56;
int MODE_SNOWBALL22_3 = 57;
int MODE_SNOWBALL22_4 = 58;
int MODE_SNOWBALL22_5 = 59;
int MODE_SNOWBALL23 = 60;
int MODE_SNOWBALL24 = 61;
int MODE_SNOWBALL25 = 62;
int MODE_SNOWBALL26 = 63;
int MODE_SNOWBALL26_1 = 64;
int MODE_SNOWBALL26_2 = 65;
int MODE_SNOWBALL26_3 = 66;
int MODE_SNOWBALL26_4 = 67;
int MODE_SNOWBALL26_5 = 68;
int MODE_SNOWBALL26_6 = 69;
int MODE_SNOWBALL26_7 = 70;
int MODE_SNOWBALL27 = 71;
int MODE_SNOWBALL28 = 72;
int MODE_SNOWBALL29 = 73;
int MODE_SNOWBALL30 = 74;
int MODE_SNOWBALL31 = 75;
int MODE_EXIT = 76;


// Giving to the 'mode' variable the initial value of
// 'MODE_SNOWBALL_00' we start the application with the
// title screen.
int mode = MODE_SNOWBALL00;


// Here all the image placeholders are declared.
PImage bgsnowball00;
PImage bgsnowball01;
PImage bgsnowball02;
PImage bgsnowball02_s1;
PImage bgsnowball02_s2;
PImage bgsnowball02_s3;
PImage bgsnowball03;
PImage bgsnowball04;
PImage bgsnowball04_s1;
PImage bgsnowball04_s2;
PImage bgsnowball05;
PImage bgsnowball06;
PImage bgsnowball07;
PImage bgsnowball08;
PImage bgsnowball08_s1;
PImage bgsnowball08_s2;
PImage bgsnowball08_s3;
PImage bgsnowball09;
PImage bgsnowball09_s1;
PImage bgsnowball09_s2;
PImage bgsnowball09_s3;
PImage bgsnowball10;
PImage bgsnowball10_s1;
PImage bgsnowball10_s2;
PImage bgsnowball10_s3;
PImage bgsnowball11;
PImage bgsnowball11_s1;
PImage bgsnowball11_s2;
PImage bgsnowball11_s3;
PImage bgsnowball12;
PImage bgsnowball13;
PImage bgsnowball13_s1;
PImage bgsnowball13_s2;
PImage bgsnowball13_s3;
PImage bgsnowball14;
PImage bgsnowball15;
PImage bgsnowball15_s1;
PImage bgsnowball15_s2;
PImage bgsnowball15_s3;
PImage bgsnowball16;
PImage bgsnowball17;
PImage bgsnowball17_s1;
PImage bgsnowball17_s2;
PImage bgsnowball17_s3;
PImage bgsnowball18;
PImage bgsnowball18_s1;
PImage bgsnowball18_s2;
PImage bgsnowball18_s3;
PImage bgsnowball19;
PImage bgsnowball20;
PImage bgsnowball20_s1;
PImage bgsnowball20_s2;
PImage bgsnowball20_s3;
PImage bgsnowball21;
PImage bgsnowball22;
PImage bgsnowball22_s1;
PImage bgsnowball22_s2;
PImage bgsnowball22_s3;
PImage bgsnowball22_s4;
PImage bgsnowball22_s5;
PImage bgsnowball23;
PImage bgsnowball24;
PImage bgsnowball25;
PImage bgsnowball26;
PImage bgsnowball26_s1;
PImage bgsnowball26_s2;
PImage bgsnowball26_s3;
PImage bgsnowball26_s4;
PImage bgsnowball26_s5;
PImage bgsnowball26_s6;
PImage bgsnowball26_s7;
PImage bgsnowball27;
PImage bgsnowball28;
PImage bgsnowball29;
PImage bgsnowball30;
PImage bgsnowball31;


// Function that loads all the images.
void loadImages()
{
  bgsnowball00 = loadImage("bg_snowball00.png");
  bgsnowball01 = loadImage("bg_snowball01.png");
  bgsnowball02 = loadImage("bg_snowball02.png");
  bgsnowball02_s1 = loadImage("bg_snowball02_selected1.png");
  bgsnowball02_s2 = loadImage("bg_snowball02_selected2.png");
  bgsnowball02_s3 = loadImage("bg_snowball02_selected3.png");
  bgsnowball03 = loadImage("bg_snowball03.png");
  bgsnowball04 = loadImage("bg_snowball04.png");
  bgsnowball04_s1 = loadImage("bg_snowball04_selected1.png");
  bgsnowball04_s2 = loadImage("bg_snowball04_selected2.png");
  bgsnowball05 = loadImage("bg_snowball05.png");
  bgsnowball06 = loadImage("bg_snowball06.png");
  bgsnowball07 = loadImage("bg_snowball07.png");
  bgsnowball08 = loadImage("bg_snowball08.png");
  bgsnowball08_s1 = loadImage("bg_snowball08_selected1.png");
  bgsnowball08_s2 = loadImage("bg_snowball08_selected2.png");
  bgsnowball08_s3 = loadImage("bg_snowball08_selected3.png");
  bgsnowball09 = loadImage("bg_snowball09.png");
  bgsnowball09_s1 = loadImage("bg_snowball09_selected1.png");
  bgsnowball09_s2 = loadImage("bg_snowball09_selected2.png");
  bgsnowball09_s3 = loadImage("bg_snowball09_selected3.png");
  bgsnowball10 = loadImage("bg_snowball10.png");
  bgsnowball10_s1 = loadImage("bg_snowball10_selected1.png");
  bgsnowball10_s2 = loadImage("bg_snowball10_selected2.png");
  bgsnowball10_s3 = loadImage("bg_snowball10_selected3.png");  
  bgsnowball11 = loadImage("bg_snowball11.png");
  bgsnowball11_s1 = loadImage("bg_snowball11_selected1.png");
  bgsnowball11_s2 = loadImage("bg_snowball11_selected2.png");
  bgsnowball11_s3 = loadImage("bg_snowball11_selected3.png");
  bgsnowball12 = loadImage("bg_snowball12.png");
  bgsnowball13 = loadImage("bg_snowball13.png");
  bgsnowball13_s1 = loadImage("bg_snowball13_selected1.png");
  bgsnowball13_s2 = loadImage("bg_snowball13_selected2.png");
  bgsnowball13_s3 = loadImage("bg_snowball13_selected3.png");
  bgsnowball14 = loadImage("bg_snowball14.png");
  bgsnowball15 = loadImage("bg_snowball15.png");
  bgsnowball15_s1 = loadImage("bg_snowball15_selected1.png");
  bgsnowball15_s2 = loadImage("bg_snowball15_selected2.png");
  bgsnowball15_s3 = loadImage("bg_snowball15_selected3.png");
  bgsnowball16 = loadImage("bg_snowball16.png");
  bgsnowball17 = loadImage("bg_snowball17.png");
  bgsnowball17_s1 = loadImage("bg_snowball17_selected1.png");
  bgsnowball17_s2 = loadImage("bg_snowball17_selected2.png");
  bgsnowball17_s3 = loadImage("bg_snowball17_selected3.png");
  bgsnowball18 = loadImage("bg_snowball18.png");
  bgsnowball18_s1 = loadImage("bg_snowball18_selected1.png");
  bgsnowball18_s2 = loadImage("bg_snowball18_selected2.png");
  bgsnowball18_s3 = loadImage("bg_snowball18_selected3.png");
  bgsnowball19 = loadImage("bg_snowball19.png");
  bgsnowball20 = loadImage("bg_snowball20.png");
  bgsnowball20_s1 = loadImage("bg_snowball20_selected1.png");
  bgsnowball20_s2 = loadImage("bg_snowball20_selected2.png");
  bgsnowball20_s3 = loadImage("bg_snowball20_selected3.png");
  bgsnowball21 = loadImage("bg_snowball21.png");
  bgsnowball22 = loadImage("bg_snowball22.png");
  bgsnowball22_s1 = loadImage("bg_snowball22_selected1.png");
  bgsnowball22_s2 = loadImage("bg_snowball22_selected2.png");
  bgsnowball22_s3 = loadImage("bg_snowball22_selected3.png");
  bgsnowball22_s4 = loadImage("bg_snowball22_selected4.png");
  bgsnowball22_s5 = loadImage("bg_snowball22_selected5.png");
  bgsnowball23 = loadImage("bg_snowball23.png");
  bgsnowball24 = loadImage("bg_snowball24.png");
  bgsnowball25 = loadImage("bg_snowball25.png");
  bgsnowball26 = loadImage("bg_snowball26.png");
  bgsnowball26_s1 = loadImage("bg_snowball26_selected1.png");
  bgsnowball26_s2 = loadImage("bg_snowball26_selected2.png");
  bgsnowball26_s3 = loadImage("bg_snowball26_selected3.png");
  bgsnowball26_s4 = loadImage("bg_snowball26_selected4.png");
  bgsnowball26_s5 = loadImage("bg_snowball26_selected5.png");
  bgsnowball26_s6 = loadImage("bg_snowball26_selected6.png");
  bgsnowball26_s7 = loadImage("bg_snowball26_selected7.png");
  bgsnowball27 = loadImage("bg_snowball27.png");
  bgsnowball28 = loadImage("bg_snowball28.png");
  bgsnowball29 = loadImage("bg_snowball29.png");
  bgsnowball30 = loadImage("bg_snowball30.png");
  bgsnowball31 = loadImage("bg_snowball31.png");

}


////////////////////////////////////////////////////////////////////
// WAIT FUNCTION
////////////////////////////////////////////////////////////////////
// This function takes a value in milliseconds and makes the device
// wait the equivalent time. Variable 'mswait' brings this value,
// which is added to the current milliseconds to obtain 'currenTime'.
// The application waits until the milliseconds reach the value of
// 'currenTime'.
void wait(int mswait)
{
  int currentTime = millis() + mswait;
  while(millis() < currentTime){}
  
}


/////////////////////////////////////////////////////////////////////
// DRAWSCREEN FUNCTION
/////////////////////////////////////////////////////////////////////
// This function reads the current mode and stores is into the variable
// 'screenNr', which is used to display a certain screen according with
// the value.
void drawScreen(int screenNr, int x, int y)
{
  switch(screenNr)
  {
  case 0:
    image(bgsnowball00, x, y);
    break;
  case 1: 
    image(bgsnowball01, x, y);
    break;
  case 2:
    image(bgsnowball02, x, y);
    mode = MODE_SNOWBALL02_1;
    break;
  case 3:
    wait(800);
    image(bgsnowball02_s1, x, y);
    break;
  case 4: 
    image(bgsnowball02_s2, x, y);
    break;
  case 5: 
    image(bgsnowball02_s3, x, y);
    break;
  case 6: 
    image(bgsnowball03, x, y);
    break;
  case 7:
    wait(800);
    image(bgsnowball04, x, y);
    break;
  case 8: 
    image(bgsnowball04_s1, x, y);
    break;
  case 9: 
    image(bgsnowball04_s2, x, y);
    break;
  case 10:
    image(bgsnowball05, x, y);
    wait(800);
    mode = MODE_SNOWBALL06;
    break;
  case 11:
    image(bgsnowball06, x, y);
    wait(800);
    mode = MODE_SNOWBALL07;
    break;
  case 12:
    image(bgsnowball07, x, y);
    wait(800);
    mode = MODE_SNOWBALL08;
    break;
  case 13:
    image(bgsnowball08, x, y);
    break;
  case 14:
    image(bgsnowball08_s1, x, y);
    break;
  case 15:
    image(bgsnowball08_s2, x, y);
    break;
  case 16:
    image(bgsnowball08_s3, x, y);
    wait(800);
    mode = MODE_SNOWBALL09;
    break;
  case 17:
    image(bgsnowball09, x, y);
    break;
  case 18:
    image(bgsnowball09_s1, x, y);
    break;
  case 19:
    image(bgsnowball09_s2, x, y);
    break;
  case 20:
    image(bgsnowball09_s3, x, y);
    wait(800);
    mode = MODE_SNOWBALL10;
    break;
  case 21:
    image(bgsnowball10, x, y);
    break;
  case 22:
    image(bgsnowball10_s1, x, y);
    break;
  case 23:
    image(bgsnowball10_s2, x, y);
    break;
  case 24:
    image(bgsnowball10_s3, x, y);
    wait(800);
    mode = MODE_SNOWBALL11;
    break;
  case 25:
    image(bgsnowball11, x, y);
    break;
  case 26:
    image(bgsnowball11_s1, x, y);
    break;
  case 27:
    image(bgsnowball11_s2, x, y);
    break;
  case 28:
    image(bgsnowball11_s3, x, y);
    wait(800);
    mode = MODE_SNOWBALL12;
    break;
  case 29:
    image(bgsnowball12, x, y);
    wait(800);
    mode = MODE_SNOWBALL13;
    break;
  case 30:
    image(bgsnowball13, x, y);
    break;
  case 31:
    image(bgsnowball13_s1, x, y);
    break;
  case 32:
    image(bgsnowball13_s2, x, y);
    break;
  case 33:
    image(bgsnowball13_s3, x, y);
    wait(800);
    mode = MODE_SNOWBALL14;
    break;
  case 34:
    image(bgsnowball14, x, y);
    wait(800);
    mode = MODE_SNOWBALL15;
    break;
  case 35:
    image(bgsnowball15, x, y);
    break;
  case 36:
    image(bgsnowball15_s1, x, y);
    break;
  case 37:
    image(bgsnowball15_s2, x, y);
    break;
  case 38:
    image(bgsnowball15_s3, x, y);
    wait(800);
    mode = MODE_SNOWBALL16;
    break;
  case 39:
    image(bgsnowball16, x, y);
    wait(800);
    mode = MODE_SNOWBALL17;
    break;
  case 40:
    image(bgsnowball17, x, y);
    break;
  case 41:
    image(bgsnowball17_s1, x, y);
    break;
  case 42:
    image(bgsnowball17_s2, x, y);
    break;
  case 43:
    image(bgsnowball17_s3, x, y);
    wait(800);
    mode = MODE_SNOWBALL18;
    break;
  case 44:
    image(bgsnowball18, x, y);
    break;
  case 45:
    image(bgsnowball18_s1, x, y);
    break;
  case 46:
    image(bgsnowball18_s2, x, y);
    break;
  case 47:
    image(bgsnowball18_s3, x, y);
    wait(800);
    mode = MODE_SNOWBALL19;
    break;
  case 48:
    image(bgsnowball19, x, y);
    wait(800);
    mode = MODE_SNOWBALL20;
    break;
  case 49:
    image(bgsnowball20, x, y);
    break;
  case 50:
    image(bgsnowball20_s1, x, y);
    break;
  case 51:
    image(bgsnowball20_s2, x, y);
    break;
  case 52:
    image(bgsnowball20_s3, x, y);
    break;
  case 53:
    image(bgsnowball21, x, y);
    break;
  case 54:
    image(bgsnowball22, x, y);
    break;
  case 55:
    image(bgsnowball22_s1, x, y);
    break;
  case 56:
    image(bgsnowball22_s2, x, y);
    break;
  case 57:
    image(bgsnowball22_s3, x, y);
    break;
  case 58:
    image(bgsnowball22_s4, x, y);
    break;
  case 59:
    image(bgsnowball22_s5, x, y);
    break;
  case 60:
    wait(800);
    image(bgsnowball23, x, y);
    mode = MODE_SNOWBALL24;
    break;
  case 61:
    wait(800);
    image(bgsnowball24, x, y);
    break;
  case 62:
    image(bgsnowball25, x, y);
    break;
  case 63:
    image(bgsnowball26, x, y);
    break;
  case 64:
    image(bgsnowball26_s1, x, y);
    break;
  case 65:
    image(bgsnowball26_s2, x, y);
    break;
  case 66:
    image(bgsnowball26_s3, x, y);
    break;
  case 67:
    image(bgsnowball26_s4, x, y);
    break;
  case 68:
    image(bgsnowball26_s5, x, y);
    break;
  case 69:
    image(bgsnowball26_s6, x, y);
    break;
  case 70:
    image(bgsnowball26_s7, x, y);
    break;
  case 71:
    image(bgsnowball27, x, y);
    break;
  case 72:
    image(bgsnowball28, x, y);
    mode = MODE_SNOWBALL29;
    break;
  case 73:
    wait(800);
    image(bgsnowball29, x, y);
    mode = MODE_SNOWBALL30;
    break;
  case 74:
    wait(800);
    image(bgsnowball30, x, y);
    break;
  case 75:
    image(bgsnowball31, x, y);
    mode = MODE_EXIT;
    break;
  case 76:
    wait(800);
    exit();
    break;
  }

}


////////////////////////////////////////////////////////////////////
// SETUP FUNCTION
////////////////////////////////////////////////////////////////////
void setup()
{
  myPhone = new Phone(this); // create new phone instance/controller
  myPhone.fullscreen(); // tell phone to go fullscreen
  loadImages(); // recall the function that loads all images

}


////////////////////////////////////////////////////////////////////
// DRAW FUNCTION
////////////////////////////////////////////////////////////////////
// This function happens repeatedly (according to framerate)
void draw()
{
  drawScreen(mode, 0, 0); // refreshes the screen recalling drawScreen function 

}


////////////////////////////////////////////////////////////////////
// KEYPRESSED FUNCTION
////////////////////////////////////////////////////////////////////
// This function happens whenever a key is pressed
// and makes the value of variable "mode" change
// according the button which is pressed
void keyPressed()
{
  
  // Conditions to exit or to restart the application
  if(keyCode == '9'){ // Hit 9 to directly exit the program
    exit();
  }
  if(keyCode == '7'){ // Hit 7 to directly come back to the start
    mode = MODE_SNOWBALL00;
  }
  
  // Changes 'mode' value according to the key that is pressed  
  switch(mode)
  {
  case 0: 
  // We are in the title screen
    if(keyCode == -7){
      mode = MODE_SNOWBALL01;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL31;
    }
    break;
  case 1:
  // We are in the snow-screen-saver screen
    if(keyCode == -6){
      mode = MODE_SNOWBALL31;
    }
    mode = MODE_SNOWBALL02;
    break;
  case 2:
  // Snowball attack #1 is recieved
    break;
  case 3:
  // The snowball attack #1 is selected and so, confirmed
    if(keyCode == UP){
      mode = MODE_SNOWBALL02_2;
    }else if(keyCode == FIRE){
      mode = MODE_SNOWBALL02;
    }
    break;
  case 4:
  // The snowball attack #1 is put into the upper-left corner if fire is pressed
    if (keyCode == FIRE){
      mode = MODE_SNOWBALL02_3;
    }else if(keyCode == DOWN){
      mode = MODE_SNOWBALL02_1;
    }
    break;
  case 5:
  // The snowball attack #1 icon stays into the upper-left corner
    if(keyCode == UP){
      mode = MODE_SNOWBALL03;
    }
    break;
  case 6:
  // The snowball attack #1 is selected for a reply
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL04;
    }else if(keyCode == DOWN){
      mode = MODE_SNOWBALL02_3;
    }
    break;
  case 7:
  // Appears the emoticons archive
    if(keyCode == DOWN){
      mode = MODE_SNOWBALL04_1;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL03;
    }
    break;
  case 8:
  // Moving down into the archive
    if(keyCode == RIGHT){
      mode = MODE_SNOWBALL04_2;
    }else if(keyCode == UP){
      mode = MODE_SNOWBALL04;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL03;
    }
    break;
  case 9:
  // Moving to the right into the archive
    if(keyCode == FIRE){
      wait(800);
      mode = MODE_SNOWBALL05;
    }else if(keyCode == LEFT){
      mode = MODE_SNOWBALL04_2;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL03;
    }
    break;
  case 10:
  // Fire button is pressed to select the emoticon for the reply.
    break;
  case 11:
  // Snowball sending message.
    break;
  case 12:
  // Waiting menu.
    mode = MODE_SNOWBALL08;
    break;
  case 13:
  // Snowball #1 arrives.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL08_1;
    }
    break;
  case 14:
  // Snowball #1 is selected.
    if(keyCode == UP){
      mode = MODE_SNOWBALL08_2;
    }else if(keyCode == FIRE){
      mode = MODE_SNOWBALL08;
    }
    break;
  case 15:
  // Snowball #1 is dragged.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL08_3;
    }else if(keyCode == DOWN){
      mode = MODE_SNOWBALL08_1;
    }
    break;
  case 16:
  // Snowball #1 is placed and confirmed.
    break;
  case 17:
  // Snowball #2 is recieved and selected.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL09_1;
    }
    break;
  case 18:
  // Snowball #2 is dragged.
    if(keyCode == UP){
      mode = MODE_SNOWBALL09_2;
    }else if(keyCode == DOWN){
      mode = MODE_SNOWBALL09;
    }
    break;
  case 19:
  // Snowball #2 is confirmed.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL09_3;
    }
    break;
  case 20:
  // Snowball #3 arrives.
    break;
  case 21:
  // Snowball #3 is arrived.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL10_1;
    }
    break;
  case 22:
  // Snowball #3 is selected.
    if(keyCode == UP){
      mode = MODE_SNOWBALL10_2;
    }else if(keyCode == FIRE){
      mode = MODE_SNOWBALL10;
    }
    break;
  case 23:
  // Snowball #3 is dragged up.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL10_3;
    }else if(keyCode == DOWN){
      mode = MODE_SNOWBALL10_1;
    }
    break;
  case 24:
  // Snowball #3 recievement is confirmed.
    break;
  case 25:
  // Snowball #4 is arrived.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL11_1;
    }
    break;
  case 26:
  // Snowball #4 is selected.
    if(keyCode == UP){
      mode = MODE_SNOWBALL11_2;
    }else if(keyCode == FIRE){
      mode = MODE_SNOWBALL11;
    }
    break;
  case 27:
  // Snowball #4 is dragged up.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL11_3;
    }else if(keyCode == DOWN){
      mode = MODE_SNOWBALL11_1;
    }
    break;
  case 28:
  // Snowball #4 recievement is confirmed.
    break;
  case 29:
  // Appeared again the waiting menu.
    break;
  case 30:
  // Snowball attack #2 is arrived.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL13_1;
    }
    break;
  case 31:
  // Snowball attack #2 is selected.
    if(keyCode == RIGHT){
      mode = MODE_SNOWBALL13_2;
    }else if(keyCode == FIRE){
      mode = MODE_SNOWBALL13;
    }
    break;
  case 32:
  // Snowball attack #2 has been dragged on the
  // upper-right corner.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL13_3;
    }else if(keyCode == LEFT){
      mode = MODE_SNOWBALL11_1;
    }
    break;
  case 33:
  // Snowball now is placed in the upper-right corner,
  // by pressing fire, so has been accepted.
    break;
  case 34:
  // waiting screen appears after 1 second.
    break;
  case 35:
  // After a wait of 3 seconds a new snowball attack arrive
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL15_1;
    }
    break;
  case 36:
  // Snowball attack #3 has been selected
    if(keyCode == DOWN){
      mode = MODE_SNOWBALL15_2;
    }else if(keyCode == FIRE){
      mode = MODE_SNOWBALL15;
    }
    break;
  case 37:
  // Snowball attack #3 has been dragged on the lower-right corner
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL15_3;
    }else if(keyCode == UP){
      mode = MODE_SNOWBALL15_1;
    }
    break;
  case 38:
  // Snowball attack #3 has been confirmed on the lower-right corner, by pressing fire, so has been accepted
    break;
  case 39:
  // After 1 second appears the waiting screen again
    break;
  case 40:
  // After 3 seconds snowball attack #4 arrives
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL17_1;
    }
    break;
  case 41:
  // Snowball attack #4 has been accepted
    if(keyCode == LEFT){
      mode = MODE_SNOWBALL17_2;
    }else if(keyCode == FIRE){
      mode = MODE_SNOWBALL17;
    }
    break;
  case 42:
  // Snowball attack #4 has been dragged on the lower-left corner
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL17_3;
    }else if(keyCode == RIGHT){
      mode = MODE_SNOWBALL17_1;
    }
   break;
  case 43:
  // Snowball attack #4 has been placed on the lower-left
  // corner by pressing fire and so it's confirmed.
    break;
  case 44:
  // Snowball #1 from user #2 has been arrived.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL18_1;
    }
    break;
  case 45:
  // Snowball #1 from user #2 has been selected.
    if(keyCode == RIGHT){
      mode = MODE_SNOWBALL18_2;
    }else if(keyCode == FIRE){
      mode = MODE_SNOWBALL18;
    }
    break;
  case 46:
  // Snowball #1 from user #2 has been dragged on the upper-right corner.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL18_3;
    }else if(keyCode == LEFT){
      mode = MODE_SNOWBALL18_1;
    }
    break;
  case 47:
  // Snowball #1 from user #2 has been placed on the
  // upper-right corner, by clicking fire, so has been accepted.
    break;
  case 48:
  // After a second the //waiting screen appears.
    break;
  case 49:
  // After 3 seconds arrives snowball #1 from user #4.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL20_1;
    }
    break;
  case 50:
  // Snowball #1 from user #4 has been selected.
    if(keyCode == LEFT){
      mode = MODE_SNOWBALL20_2;
    }else if(keyCode == FIRE){
      mode = MODE_SNOWBALL20;
    }
    break;
  case 51:
  // Snowball #1 from user #4 has been dragged
  // on the lower-left corner.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL20_3;
    }else if(keyCode == RIGHT){
      mode = MODE_SNOWBALL20_1;
    }
    break;
  case 52:
  // Snowball #1 from user #4 has been placed on the
  // lower-left corner, by clicking fire, so has been accepted.
    if(keyCode == RIGHT){
      mode = MODE_SNOWBALL21;
    }
    break;
  case 53:
  // The upper-right user has been focused probably
  // because I want to reply him.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL22;
    }else if(keyCode == LEFT){
      mode = MODE_SNOWBALL20_3;
    }
    break;
  case 54:
  // I clicked FIRE while user #2 was focused so I
  // enter into the emoticons archive.
    if(keyCode == DOWN){
      mode = MODE_SNOWBALL22_1;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL21;
    }
    break;
  case 55:
  // Moving down into the menu.
    if(keyCode == RIGHT){
      mode = MODE_SNOWBALL22_2;
    }else if(keyCode == UP){
      mode = MODE_SNOWBALL22;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL21;
    }
    break;
  case 56:
  // Moving right into the menu.
    if(keyCode == RIGHT){
      mode = MODE_SNOWBALL22_3;
    }else if(keyCode == LEFT){
      mode = MODE_SNOWBALL22_1;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL21;
    }
    break;
  case 57:
  // Moving right into the menu.
    if(keyCode == RIGHT){
      mode = MODE_SNOWBALL22_4;
    }else if(keyCode == LEFT){
      mode = MODE_SNOWBALL22_2;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL21;
    }
    break;
  case 58:
  // Moving right into the menu.
    if(keyCode == RIGHT){
      mode = MODE_SNOWBALL22_5;
    }else if(keyCode == LEFT){
      mode = MODE_SNOWBALL22_3;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL21;
    }
    break;
  case 59:
  // Moving right into the menu.
    if(keyCode == FIRE){
      wait(800);
      mode = MODE_SNOWBALL23;
    }else if(keyCode == LEFT){
      mode = MODE_SNOWBALL22_4;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL21;
    }
    break;
  case 60:
  // Moving right into the menu.
    break;
  case 61:
  // After 2 seconds the 'snowball sent' message appear.
    if(keyCode == DOWN){
      mode = MODE_SNOWBALL25;
    }
    break;
  case 62:
  // After 1 second I pressed down so I've been directly
  // redirected to the snowball attacks screen.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL26;
    }
    break;
  case 63:
  // I pressed fire on the icon of user #3.
    if(keyCode == DOWN){
      mode = MODE_SNOWBALL26_1;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL25;
    }
    break;
  case 64:
  // Moving down in the archive.
    if(keyCode == DOWN){
      mode = MODE_SNOWBALL26_2;
    }else if(keyCode == UP){
      mode = MODE_SNOWBALL26;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL25;
    }
    break;
  case 65:
  // Moving down into the archive.
    if(keyCode == DOWN){
      mode = MODE_SNOWBALL26_3;
    }else if(keyCode == UP){
      mode = MODE_SNOWBALL26_1;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL25;
    }
    break;
  case 66:
  // Moving down into the archive.
    if(keyCode == RIGHT){
      mode = MODE_SNOWBALL26_4;
    }else if(keyCode == UP){
      mode = MODE_SNOWBALL26_2;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL25;
    }
    break;
  case 67:
 // Moving right into the archive.
    if(keyCode == RIGHT){
      mode = MODE_SNOWBALL26_5;
    }else if(keyCode == LEFT){
      mode = MODE_SNOWBALL26_3;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL25;
    }
    break;
  case 68:
 // Moving right into the archive.
    if(keyCode == RIGHT){
      mode = MODE_SNOWBALL26_6;
    }else if(keyCode == LEFT){
      mode = MODE_SNOWBALL26_4;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL25;
    }
    break;
  case 69:
 // Moving right into the archive.
    if(keyCode == RIGHT){
      mode = MODE_SNOWBALL26_7;
    }else if(keyCode == LEFT){
      mode = MODE_SNOWBALL26_5;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL25;
    }
    break;
  case 70:
 // Moving right into the archive.
    if(keyCode == FIRE){
      mode = MODE_SNOWBALL27;
    }else if(keyCode == LEFT){
      mode = MODE_SNOWBALL26_6;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL25;
    }
    break;
  case 71:
 // Pressing fire on the selected emoticon, in this case
 // it is special beacuse it's the icon for sending a message.
    if(keyCode == -7){
      mode = MODE_SNOWBALL28;
    }else if(keyCode == -6){
      mode = MODE_SNOWBALL26_7;
    }
    break;
  case 72:
  // 'Sending message' screen appears after 5 seconds.
    break;
  case 73:
  // 'Message sent' appears after 2 seconds.
    break;
  case 74:
  // Returned to the waiting screen.
    if(keyCode == -6){
      mode = MODE_SNOWBALL31;
    }
    break;
  case 75:
  // Switched off the service.
    break;
  }

}
